| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
cv::gapi::wip::onevpl::CfgParam Struct Reference

Public class is using for creation of onevpl::GSource instances. More...

`#include <opencv2/gapi/streaming/onevpl/cfg_params.hpp>`

Collaboration diagram for cv::gapi::wip::onevpl::CfgParam:

## Public Types
using | name_t = std::string
using | value_t

## Public Member Functions
| CfgParam (CfgParam &&src)
| CfgParam (const CfgParam &src)
| ~CfgParam ()
const name_t & | get_name () const
const value_t & | get_value () const
bool | is_major () const
bool | operator!= (const CfgParam &rhs) const
bool | operator< (const CfgParam &rhs) const
CfgParam & | operator= (CfgParam &&src)
CfgParam & | operator= (const CfgParam &src)
bool | operator== (const CfgParam &rhs) const
std::string | to_string () const

## Static Public Member Functions
static constexpr const char * | acceleration_mode_name ()
| acceleration_mode_name
template<typename ValueType >
static CfgParam | create (const std::string &name, ValueType &&value, bool is_major=true)
static CfgParam | create_acceleration_mode (const char *value)
static CfgParam | create_acceleration_mode (uint32_t value)
static CfgParam | create_decoder_id (const char *value)
static CfgParam | create_decoder_id (uint32_t value)
static CfgParam | create_frames_pool_size (size_t value)
static CfgParam | create_implementation (const char *value)
static CfgParam | create_implementation (uint32_t value)
static CfgParam | create_vpp_frames_pool_size (size_t value)
static CfgParam | create_vpp_in_crop_h (uint16_t value)
static CfgParam | create_vpp_in_crop_w (uint16_t value)
static CfgParam | create_vpp_in_crop_x (uint16_t value)
static CfgParam | create_vpp_in_crop_y (uint16_t value)
static CfgParam | create_vpp_in_height (uint16_t value)
static CfgParam | create_vpp_in_width (uint16_t value)
static CfgParam | create_vpp_out_chroma_format (uint16_t value)
static CfgParam | create_vpp_out_crop_h (uint16_t value)
static CfgParam | create_vpp_out_crop_w (uint16_t value)
static CfgParam | create_vpp_out_crop_x (uint16_t value)
static CfgParam | create_vpp_out_crop_y (uint16_t value)
static CfgParam | create_vpp_out_fourcc (uint32_t value)
static CfgParam | create_vpp_out_framerate_d (uint32_t value)
static CfgParam | create_vpp_out_framerate_n (uint32_t value)
static CfgParam | create_vpp_out_height (uint16_t value)
static CfgParam | create_vpp_out_pic_struct (uint16_t value)
static CfgParam | create_vpp_out_width (uint16_t value)
static constexpr const char * | decoder_id_name ()
| decoder_id_name
static constexpr const char * | frames_pool_size_name ()
| frames_pool_size_name
static constexpr const char * | implementation_name ()
static constexpr const char * | vpp_frames_pool_size_name ()
static constexpr const char * | vpp_in_crop_h_name ()
static constexpr const char * | vpp_in_crop_w_name ()
static constexpr const char * | vpp_in_crop_x_name ()
static constexpr const char * | vpp_in_crop_y_name ()
static constexpr const char * | vpp_in_height_name ()
static constexpr const char * | vpp_in_width_name ()
static constexpr const char * | vpp_out_chroma_format_name ()
static constexpr const char * | vpp_out_crop_h_name ()
static constexpr const char * | vpp_out_crop_w_name ()
static constexpr const char * | vpp_out_crop_x_name ()
static constexpr const char * | vpp_out_crop_y_name ()
static constexpr const char * | vpp_out_fourcc_name ()
static constexpr const char * | vpp_out_framerate_d_name ()
static constexpr const char * | vpp_out_framerate_n_name ()
static constexpr const char * | vpp_out_height_name ()
static constexpr const char * | vpp_out_pic_struct_name ()
static constexpr const char * | vpp_out_width_name ()

## Detailed Description

Public class is using for creation of onevpl::GSource instances.

Class members available through methods CfgParam::get_name() and CfgParam::get_value() are used by onevpl::GSource inner logic to create or find oneVPL particular implementation (software/hardware, specific API version and etc.).

Note
  Because oneVPL may provide several implementations which are satisfying with multiple (or single one) CfgParam criteria therefore it is possible to configure `preferred` parameters. This kind of CfgParams are created using `is_major = false` argument in CfgParam::create method and are not used by creating oneVPL particular implementations. Instead they fill out a "score table" to select preferable implementation from available list. Implementation are satisfying with most of these optional params would be chosen. If no one optional CfgParam params were present then first of available oneVPL implementation would be applied. Please get on https://spec.oneapi.io/versions/latest/elements/oneVPL/source/API_ref/VPL_disp_api_func.html?highlight=mfxcreateconfig#mfxsetconfigfilterproperty for using OneVPL configuration. In this schema `mfxU8 *name` represents CfgParam::get_name() and `mfxVariant value` is CfgParam::get_value()

## Member Typedef Documentation

## ◆ name_t

using cv::gapi::wip::onevpl::CfgParam::name_t = std::string

## ◆ value_t

using cv::gapi::wip::onevpl::CfgParam::value_t

Initial value:
cv::util::variant<uint8_t, int8_t,
uint16_t, int16_t,
uint32_t, int32_t,
uint64_t, int64_t,
float_t,
double_t,
void*,
std::string>
cv::util::variant
Definition variant.hpp:72

## Constructor & Destructor Documentation

## ◆ CfgParam() [1/2]

cv::gapi::wip::onevpl::CfgParam::CfgParam | ( | const CfgParam & | src | ) |

## ◆ CfgParam() [2/2]

cv::gapi::wip::onevpl::CfgParam::CfgParam | ( | CfgParam && | src | ) |

## ◆ ~CfgParam()

cv::gapi::wip::onevpl::CfgParam::~CfgParam | ( |  | ) |

## Member Function Documentation

## ◆ acceleration_mode_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::acceleration_mode_name | ( |  | ) |
| inline static constexpr

acceleration_mode_name

Special configuration parameter names for onevp::GSource:

Note
  acceleration_mode_name allows to activate hardware acceleration & device memory management. Supported values:
  - MFX_ACCEL_MODE_VIA_D3D11 Will activate DX11 acceleration and will produces MediaFrames with data allocated in DX11 device memory

If not set then MFX implementation will use default acceleration behavior: all decoding operation uses default GPU resources but MediaFrame produces data allocated by using host RAM

## ◆ create()

template<typename ValueType >

static CfgParam cv::gapi::wip::onevpl::CfgParam::create | ( | const std::string & | name,
|  | ValueType && | value,
|  | bool | is_major = true )
| inline static

Create generic onevp::GSource configuration parameter.

Parameters

  name | name of parameter.
  value | value of parameter.
  is_major | TRUE if parameter MUST be provided by OneVPL inner implementation, FALSE for optional (for resolve multiple available implementations).

## ◆ create_acceleration_mode() [1/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_acceleration_mode | ( | const char * | value | ) |
| static

## ◆ create_acceleration_mode() [2/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_acceleration_mode | ( | uint32_t | value | ) |
| static

## ◆ create_decoder_id() [1/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_decoder_id | ( | const char * | value | ) |
| static

## ◆ create_decoder_id() [2/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_decoder_id | ( | uint32_t | value | ) |
| static

## ◆ create_frames_pool_size()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_frames_pool_size | ( | size_t | value | ) |
| static

## ◆ create_implementation() [1/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_implementation | ( | const char * | value | ) |
| static

## ◆ create_implementation() [2/2]

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_implementation | ( | uint32_t | value | ) |
| static

## ◆ create_vpp_frames_pool_size()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_frames_pool_size | ( | size_t | value | ) |
| static

## ◆ create_vpp_in_crop_h()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_crop_h | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_in_crop_w()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_crop_w | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_in_crop_x()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_crop_x | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_in_crop_y()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_crop_y | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_in_height()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_height | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_in_width()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_in_width | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_chroma_format()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_chroma_format | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_crop_h()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_crop_h | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_crop_w()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_crop_w | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_crop_x()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_crop_x | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_crop_y()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_crop_y | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_fourcc()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_fourcc | ( | uint32_t | value | ) |
| static

## ◆ create_vpp_out_framerate_d()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_framerate_d | ( | uint32_t | value | ) |
| static

## ◆ create_vpp_out_framerate_n()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_framerate_n | ( | uint32_t | value | ) |
| static

## ◆ create_vpp_out_height()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_height | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_pic_struct()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_pic_struct | ( | uint16_t | value | ) |
| static

## ◆ create_vpp_out_width()

static CfgParam cv::gapi::wip::onevpl::CfgParam::create_vpp_out_width | ( | uint16_t | value | ) |
| static

## ◆ decoder_id_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::decoder_id_name | ( |  | ) |
| inline static constexpr

decoder_id_name

Special configuration parameter names for onevp::GSource:

Note
  decoder_id_name allows to specify VPL decoder type which MUST present in case of RAW video input data and MUST NOT present as CfgParam if video stream incapsulated into container(*.mp4, *.mkv and so on). In latter case onevp::GSource will determine it automatically Supported values:
  - MFX_CODEC_AVC
  - MFX_CODEC_HEVC
  - MFX_CODEC_MPEG2
  - MFX_CODEC_VC1
  - MFX_CODEC_CAPTURE
  - MFX_CODEC_VP9
  - MFX_CODEC_AV1

## ◆ frames_pool_size_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::frames_pool_size_name | ( |  | ) |
| inline static constexpr

frames_pool_size_name

Special configuration parameter name for onevp::GSource:

Note
  frames_pool_size_name allows to allocate surfaces pool appropriate size to keep decoded frames in accelerator memory ready before they would be consumed by onevp::GSource::pull operation. If you see a lot of WARNING about lack of free surface then it's time to increase frames_pool_size_name but be aware of accelerator free memory volume. If not set then MFX implementation use mfxFrameAllocRequest::NumFrameSuggested behavior

## ◆ get_name()

const name_t & cv::gapi::wip::onevpl::CfgParam::get_name | ( |  | ) | const

## ◆ get_value()

const value_t & cv::gapi::wip::onevpl::CfgParam::get_value | ( |  | ) | const

## ◆ implementation_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::implementation_name | ( |  | ) |
| inline static constexpr

## ◆ is_major()

bool cv::gapi::wip::onevpl::CfgParam::is_major | ( |  | ) | const

## ◆ operator!=()

bool cv::gapi::wip::onevpl::CfgParam::operator!= | ( | const CfgParam & | rhs | ) | const

## ◆ operator<()

bool cv::gapi::wip::onevpl::CfgParam::operator< | ( | const CfgParam & | rhs | ) | const

## ◆ operator=() [1/2]

CfgParam & cv::gapi::wip::onevpl::CfgParam::operator= | ( | CfgParam && | src | ) |

## ◆ operator=() [2/2]

CfgParam & cv::gapi::wip::onevpl::CfgParam::operator= | ( | const CfgParam & | src | ) |

## ◆ operator==()

bool cv::gapi::wip::onevpl::CfgParam::operator== | ( | const CfgParam & | rhs | ) | const

## ◆ to_string()

std::string cv::gapi::wip::onevpl::CfgParam::to_string | ( |  | ) | const

## ◆ vpp_frames_pool_size_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_frames_pool_size_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_crop_h_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_crop_h_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_crop_w_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_crop_w_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_crop_x_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_crop_x_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_crop_y_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_crop_y_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_height_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_height_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_in_width_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_in_width_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_chroma_format_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_chroma_format_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_crop_h_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_crop_h_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_crop_w_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_crop_w_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_crop_x_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_crop_x_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_crop_y_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_crop_y_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_fourcc_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_fourcc_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_framerate_d_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_framerate_d_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_framerate_n_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_framerate_n_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_height_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_height_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_pic_struct_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_pic_struct_name | ( |  | ) |
| inline static constexpr

## ◆ vpp_out_width_name()

static constexpr const char * cv::gapi::wip::onevpl::CfgParam::vpp_out_width_name | ( |  | ) |
| inline static constexpr

The documentation for this struct was generated from the following file:

- opencv2/gapi/streaming/onevpl/cfg_params.hpp